Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# ACE_Fixed_Set< T, ACE_SIZE > Class Template Reference

Implement a simple unordered set of {T} with maximum {ACE_SIZE}. More...

`#include <Containers_T.h>`

Collaboration diagram for ACE_Fixed_Set< T, ACE_SIZE >:

[legend]
List of all members.

## Public Types
typedef ACE_Fixed_Set_Iterator< T, ACE_SIZE > | ITERATOR
typedef ACE_Fixed_Set_Const_Iterator< T, ACE_SIZE > | CONST_ITERATOR
## Public Member Functions
| ACE_Fixed_Set (void)
| Default Constructor.
| ACE_Fixed_Set (const ACE_Fixed_Set< T, ACE_SIZE > &)
| Copy constructor.
void | operator= (const ACE_Fixed_Set< T, ACE_SIZE > &)
| Assignment operator.
| ~ACE_Fixed_Set (void)
| Destructor.
int | is_empty (void) const
| Returns 1 if the container is empty, otherwise returns 0.
int | is_full (void) const
| Returns 1 if the container is full, otherwise returns 0.
int | insert (const T &new_item)
| Linear time insertion of an item unique to the set.
int | remove (const T &item)
| Linear time removal operation of an item.
int | find (const T &item) const
| Finds if item occurs in the set. Returns 0 if finds, else -1.
size_t | size (void) const
| Size of the set.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Attributes
struct {
T item_
| Item in the set.
int is_free_
| Keeps track of whether this item is in use or not.
} | search_structure_ [ACE_SIZE]
| Holds the contents of the set.
size_t | cur_size_
| Current size of the set.
size_t | max_size_
| Maximum size of the set.
## Friends
class | ACE_Fixed_Set_Iterator_Base<T, ACE_SIZE>
class | ACE_Fixed_Set_Iterator<T, ACE_SIZE>
class | ACE_Fixed_Set_Const_Iterator<T, ACE_SIZE>

## Detailed Description

### template<class T, size_t ACE_SIZE>
class ACE_Fixed_Set< T, ACE_SIZE >

Implement a simple unordered set of {T} with maximum {ACE_SIZE}.

This implementation of an unordered set uses a fixed array. It does not allow duplicate members. The set provides linear insertion/deletion operations.

Requirements and Performance Characteristics

- Internal Structure Fixed array
- Duplicates allowed? No
- Random access allowed? No
- Search speed Linear
- Insert/replace speed Linear
- Iterator still valid after change to container? Yes
- Frees memory for removed elements? No
- Items inserted by Value
- Requirements for contained type
  1. Default constructor
  2. Copy constructor
  3. operator=
  4. operator==

## Member Typedef Documentation

template<class T, size_t ACE_SIZE>
typedef ACE_Fixed_Set_Const_Iterator<T, ACE_SIZE> ACE_Fixed_Set< T, ACE_SIZE >::CONST_ITERATOR

template<class T, size_t ACE_SIZE>
typedef ACE_Fixed_Set_Iterator<T, ACE_SIZE> ACE_Fixed_Set< T, ACE_SIZE >::ITERATOR

## Constructor & Destructor Documentation

template<class T, size_t ACE_SIZE>
ACE_Fixed_Set< T, ACE_SIZE >::ACE_Fixed_Set | ( | void |  | ) |

| Default Constructor. Creates an empy set

template<class T, size_t ACE_SIZE>
ACE_Fixed_Set< T, ACE_SIZE >::ACE_Fixed_Set | ( | const ACE_Fixed_Set< T, ACE_SIZE > & |  | ) |

| Copy constructor. Initializes a set to be a copy of the set parameter.

template<class T, size_t ACE_SIZE>
ACE_Fixed_Set< T, ACE_SIZE >::~ACE_Fixed_Set | ( | void |  | ) |

| Destructor. Destroys a set.

## Member Function Documentation

template<class T, size_t ACE_SIZE>
void ACE_Fixed_Set< T, ACE_SIZE >::dump | ( | void |  | ) | const

| Dump the state of an object.

template<class T, size_t ACE_SIZE>
int ACE_Fixed_Set< T, ACE_SIZE >::find | ( | const T & | item | ) | const

| Finds if item occurs in the set. Returns 0 if finds, else -1. Performs a linear find operation for the specified item.

template<class T, size_t ACE_SIZE>
int ACE_Fixed_Set< T, ACE_SIZE >::insert | ( | const T & | new_item | ) |

| Linear time insertion of an item unique to the set. Insert new_item into the set (doesn't allow duplicates). Returns -1 if failures occur, 1 if item is already present, else 0.

template<class T, size_t ACE_SIZE>
ACE_INLINE int ACE_Fixed_Set< T, ACE_SIZE >::is_empty | ( | void |  | ) | const

| Returns 1 if the container is empty, otherwise returns 0. Performs constant time check to determine if a set is empty.

template<class T, size_t ACE_SIZE>
ACE_INLINE int ACE_Fixed_Set< T, ACE_SIZE >::is_full | ( | void |  | ) | const

| Returns 1 if the container is full, otherwise returns 0. Performs a constant time check to see if the set is full.

template<class T, size_t ACE_SIZE>
void ACE_Fixed_Set< T, ACE_SIZE >::operator= | ( | const ACE_Fixed_Set< T, ACE_SIZE > & |  | ) |

| Assignment operator. Deep copy of one set to another.

template<class T, size_t ACE_SIZE>
int ACE_Fixed_Set< T, ACE_SIZE >::remove | ( | const T & | item | ) |

| Linear time removal operation of an item. Remove first occurrence of {item} from the set. Returns 0 if it removes the item, -1 if it can't find the item, and -1 if a failure occurs. Removal doesn't reclaim memory for the item.

template<class T, size_t ACE_SIZE>
size_t ACE_Fixed_Set< T, ACE_SIZE >::size | ( | void |  | ) | const

| Size of the set. Returns the current size of the set.

## Friends And Related Function Documentation

template<class T, size_t ACE_SIZE>
friend class ACE_Fixed_Set_Const_Iterator<T, ACE_SIZE>`[friend]`

template<class T, size_t ACE_SIZE>
friend class ACE_Fixed_Set_Iterator<T, ACE_SIZE>`[friend]`

template<class T, size_t ACE_SIZE>
friend class ACE_Fixed_Set_Iterator_Base<T, ACE_SIZE>`[friend]`

## Member Data Documentation

template<class T, size_t ACE_SIZE>
ACE_Fixed_Set< T, ACE_SIZE >::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<class T, size_t ACE_SIZE>
size_t ACE_Fixed_Set< T, ACE_SIZE >::cur_size_`[private]`

| Current size of the set.

template<class T, size_t ACE_SIZE>
int ACE_Fixed_Set< T, ACE_SIZE >::is_free_`[private]`

| Keeps track of whether this item is in use or not.

template<class T, size_t ACE_SIZE>
T ACE_Fixed_Set< T, ACE_SIZE >::item_`[private]`

| Item in the set.

template<class T, size_t ACE_SIZE>
size_t ACE_Fixed_Set< T, ACE_SIZE >::max_size_`[private]`

| Maximum size of the set.

struct { ... } ACE_Fixed_Set< T, ACE_SIZE >::search_structure_[ACE_SIZE]`[private]`

| Holds the contents of the set.

The documentation for this class was generated from the following files:

- Containers_T.h
- Containers_T.cpp
- Containers_T.inl